
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : No
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_LCD_init_masiv:
	.DB  0x74,0x0,0x0,0x76,0x0,0x1,0x74,0x0
	.DB  0x7,0x76,0x0,0x0,0x74,0x0,0x2,0x76
	.DB  0x4,0x0,0x74,0x0,0x4,0x76,0x0,0x0
	.DB  0x74,0x0,0xC,0x76,0x0,0x1,0x74,0x0
	.DB  0xD,0x76,0x6,0x16,0x74,0x0,0x1E,0x76
	.DB  0x10,0x10,0x74,0x0,0x3,0x76,0x0,0xC
	.DB  0x74,0x0,0xE,0x76,0x2D,0x1F,0x74,0x0
	.DB  0xD,0x76,0x6,0x16,0x74,0x0,0x1,0x76
	.DB  0x2,0x15,0x74,0x0,0xF,0x76,0x0,0x0
	.DB  0x74,0x0,0xB,0x76,0x0,0x0,0x74,0x0
	.DB  0x11,0x76,0x0,0x0,0x74,0x0,0x6,0x76
	.DB  0x0,0x0,0x74,0x0,0x5,0x76,0x0,0x30
	.DB  0x74,0x0,0x14,0x76,0xAF,0x0,0x74,0x0
	.DB  0x15,0x76,0x0,0x0,0x74,0x0,0x16,0x76
	.DB  0x83,0x0,0x74,0x0,0x17,0x76,0xAF,0x0
	.DB  0x74,0x0,0x20,0x76,0x0,0x0,0x74,0x0
	.DB  0x30,0x76,0x0,0x0,0x74,0x0,0x31,0x76
	.DB  0x4,0x0,0x74,0x0,0x32,0x76,0x2,0x7
	.DB  0x74,0x0,0x33,0x76,0x7,0x0,0x74,0x0
	.DB  0x34,0x76,0x0,0x5,0x74,0x0,0x35,0x76
	.DB  0x7,0x3,0x74,0x0,0x36,0x76,0x7,0x7
	.DB  0x74,0x0,0x37,0x76,0x0,0x7,0x74,0x0
	.DB  0x3A,0x76,0x12,0x0,0x74,0x0,0x3B,0x76
	.DB  0x0,0x9,0x74,0x0,0x7,0x76,0x0,0x5
	.DB  0x74,0x0,0x7,0x76,0x0,0x25,0x74,0x0
	.DB  0x7,0x76,0x0,0x27,0x74,0x0,0x7,0x76
	.DB  0x0,0x37
_LCD_off_masiv:
	.DB  0x74,0x0,0xD,0x76,0x5,0x5,0x74,0x0
	.DB  0xE,0x76,0x1D,0x1F,0x74,0x0,0x3,0x76
	.DB  0x0,0x0
_LCD_fill_masiv:
	.DB  0x74,0x0,0x16,0x76,0x83,0x0,0x74,0x0
	.DB  0x17,0x76,0xAF,0x0,0x74,0x0,0x21,0x76
	.DB  0x0,0x0,0x74,0x0,0x22
_LCD_kvadrat_masiv:
	.DB  0x74,0x0,0x16,0x76,0x50,0x25,0x74,0x0
	.DB  0x17,0x76,0x50,0x25,0x74,0x0,0x21,0x76
	.DB  0x25,0x25,0x74,0x0,0x22

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;flash unsigned char LCD_init_masiv[70][3] ={
;                                      {0x74,0x00,0x00}, //1 block
;                                      {0x76,0x00,0x01},
;                                      {0x74,0x00,0x07},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x02},
;                                      {0x76,0x04,0x00},
;                                      {0x74,0x00,0x04},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x0C},
;                                      {0x76,0x00,0x01},
;                                      {0x74,0x00,0x0D},
;                                      {0x76,0x06,0x16},
;                                      {0x74,0x00,0x1E},
;                                      {0x76,0x10,0x10}, //2 block
;                                      {0x74,0x00,0x03},
;                                      {0x76,0x00,0x0C},
;                                      {0x74,0x00,0x0E},
;                                      {0x76,0x2D,0x1F},
;                                      {0x74,0x00,0x0D},
;                                      {0x76,0x06,0x16},
;                                      {0x74,0x00,0x01},
;                                      {0x76,0x02,0x15},
;                                      {0x74,0x00,0x0F},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x0B},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x11},
;                                      {0x76,0x00,0x00}, //3 block
;                                      {0x74,0x00,0x06},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x05},
;                                      {0x76,0x00,0x30},
;                                      {0x74,0x00,0x14},
;                                      {0x76,0xAF,0x00},
;                                      {0x74,0x00,0x15},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x16},
;                                      {0x76,0x83,0x00},
;                                      {0x74,0x00,0x17},
;                                      {0x76,0xAF,0x00},
;                                      {0x74,0x00,0x20},
;                                      {0x76,0x00,0x00}, //4 block
;                                      {0x74,0x00,0x30},
;                                      {0x76,0x00,0x00},
;                                      {0x74,0x00,0x31},
;                                      {0x76,0x04,0x00},
;                                      {0x74,0x00,0x32},
;                                      {0x76,0x02,0x07},
;                                      {0x74,0x00,0x33},
;                                      {0x76,0x07,0x00},
;                                      {0x74,0x00,0x34},
;                                      {0x76,0x00,0x05},
;                                      {0x74,0x00,0x35},
;                                      {0x76,0x07,0x03},
;                                      {0x74,0x00,0x36},
;                                      {0x76,0x07,0x07}, //5 blocl
;                                      {0x74,0x00,0x37},
;                                      {0x76,0x00,0x07},
;                                      {0x74,0x00,0x3A},
;                                      {0x76,0x12,0x00},
;                                      {0x74,0x00,0x3B},
;                                      {0x76,0x00,0x09},
;                                      {0x74,0x00,0x07},
;                                      {0x76,0x00,0x05},
;                                      {0x74,0x00,0x07},
;                                      {0x76,0x00,0x25},
;                                      {0x74,0x00,0x07},
;                                      {0x76,0x00,0x27},
;                                      {0x74,0x00,0x07},
;                                      {0x76,0x00,0x37}
;                                     };
;
;flash unsigned char LCD_off_masiv[6][3] = {                    //masiv dlya viklyu4eniya
;                                      0x74,0x00,0x0D,
;                                      0x76,0x05,0x05,
;                                      0x74,0x00,0x0E,
;                                      0x76,0x1D,0x1F,
;                                      0x74,0x00,0x03,
;                                      0x76,0x00,0x00
;                                         };
;
;flash unsigned char LCD_fill_masiv[7][3] = {                 //masiv dlya zapolneniya ekrana
;                                      0x74,0x00,0x16,
;                                      0x76,0x83,0x00,
;                                      0x74,0x00,0x17,
;                                      0x76,0xAF,0x00,
;                                      0x74,0x00,0x21,
;                                      0x76,0x00,0x00,
;                                      0x74,0x00,0x22
;                                      };
;
;flash unsigned char LCD_kvadrat_masiv[7][3] = {                 //masiv dlya zapolneniya kvadrata
;                                      0x74,0x00,0x16,
;                                      0x76,0x50,0x25,           //        X2                  X1
;                                      0x74,0x00,0x17,
;                                      0x76,0x50,0x25,           //        Y2                  Y1
;                                      0x74,0x00,0x21,
;                                      0x76,0x25,0x25,           //        X1                  Y1
;                                      0x74,0x00,0x22
;                                      };
;
;
;
;void Port_init(void){
; 0000 006D void Port_init(void){

	.CSEG
_Port_init:
; 0000 006E DDRB=0b11111111;  //vse linii kak vixod
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 006F PORTB=0b00100100; // DAT=1 i RS=1
	LDI  R30,LOW(36)
	OUT  0x18,R30
; 0000 0070 
; 0000 0071 SPCR=0b01010001;  // master, SPI-ON, CK/16
	LDI  R30,LOW(81)
	OUT  0xD,R30
; 0000 0072 SPSR=0b00000001;  // SPI*2
	LDI  R30,LOW(1)
	OUT  0xE,R30
; 0000 0073 
; 0000 0074 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0075 DDRD=0xff;
	LDI  R30,LOW(255)
	OUT  0x11,R30
; 0000 0076 }
	RET
;
;void LCD_init(void){     // Inicializiruyu Display
; 0000 0078 void LCD_init(void){
_LCD_init:
; 0000 0079 unsigned char i=0;
; 0000 007A PORTB=0b00110100;
	ST   -Y,R17
;	i -> R17
	LDI  R17,0
	LDI  R30,LOW(52)
	OUT  0x18,R30
; 0000 007B delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x0
; 0000 007C PORTB=0b00111100;
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 007D delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x0
; 0000 007E PORTB=0b00101100;
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 007F for(i=0;i<=69;i++){
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,70
	BRSH _0x5
; 0000 0080 
; 0000 0081         SPDR=LCD_init_masiv[i][0];
	RCALL SUBOPT_0x1
	LPM  R0,Z
	OUT  0xF,R0
; 0000 0082         while (!(SPSR & 0x80));
_0x6:
	SBIS 0xE,7
	RJMP _0x6
; 0000 0083 
; 0000 0084         SPDR=LCD_init_masiv[i][1];
	RCALL SUBOPT_0x1
	ADIW R30,1
	LPM  R0,Z
	OUT  0xF,R0
; 0000 0085         while (!(SPSR & 0x80));
_0x9:
	SBIS 0xE,7
	RJMP _0x9
; 0000 0086 
; 0000 0087         SPDR=LCD_init_masiv[i][2];
	RCALL SUBOPT_0x1
	ADIW R30,2
	LPM  R0,Z
	OUT  0xF,R0
; 0000 0088         while (!(SPSR & 0x80));
_0xC:
	SBIS 0xE,7
	RJMP _0xC
; 0000 0089 
; 0000 008A PORTB=0b00111100; //neoktivniy displey
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 008B #asm("nop")
	nop
; 0000 008C PORTB=0b00101100; //oktivniy display
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 008D };
	SUBI R17,-1
	RJMP _0x4
_0x5:
; 0000 008E PORTB=0b00111100; //neoktivniy displey
	RJMP _0x2000002
; 0000 008F }
;
;void LCD_fill(void){
; 0000 0091 void LCD_fill(void){
_LCD_fill:
; 0000 0092 unsigned char i=0;
; 0000 0093 unsigned int i1;
; 0000 0094 PORTB=0b00101100; //oktivniy display
	RCALL SUBOPT_0x2
;	i -> R17
;	i1 -> R18,R19
; 0000 0095 for(i=0;i<=6;i++){
_0x10:
	CPI  R17,7
	BRSH _0x11
; 0000 0096         SPDR=LCD_fill_masiv[i][0];
	RCALL SUBOPT_0x3
	LPM  R0,Z
	OUT  0xF,R0
; 0000 0097         while (!(SPSR & 0x80));
_0x12:
	SBIS 0xE,7
	RJMP _0x12
; 0000 0098 
; 0000 0099         SPDR=LCD_fill_masiv[i][1];
	RCALL SUBOPT_0x3
	ADIW R30,1
	LPM  R0,Z
	OUT  0xF,R0
; 0000 009A         while (!(SPSR & 0x80));
_0x15:
	SBIS 0xE,7
	RJMP _0x15
; 0000 009B 
; 0000 009C         SPDR=LCD_fill_masiv[i][2];
	RCALL SUBOPT_0x3
	ADIW R30,2
	LPM  R0,Z
	OUT  0xF,R0
; 0000 009D         while (!(SPSR & 0x80));
_0x18:
	SBIS 0xE,7
	RJMP _0x18
; 0000 009E 
; 0000 009F PORTB=0b00111100; //neoktivniy displey
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 00A0 #asm("nop")
	nop
; 0000 00A1 PORTB=0b00101100; //oktivniy display
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 00A2 };
	SUBI R17,-1
	RJMP _0x10
_0x11:
; 0000 00A3         SPDR=0x76;
	LDI  R30,LOW(118)
	OUT  0xF,R30
; 0000 00A4         while (!(SPSR & 0x80));
_0x1B:
	SBIS 0xE,7
	RJMP _0x1B
; 0000 00A5 
; 0000 00A6 for(i1=0;i1<=23232;i1++){                //cvet fona goltiy
	__GETWRN 18,19,0
_0x1F:
	__CPWRN 18,19,23233
	BRSH _0x20
; 0000 00A7         SPDR=0xFF;
	LDI  R30,LOW(255)
	OUT  0xF,R30
; 0000 00A8         while (!(SPSR & 0x80));
_0x21:
	SBIS 0xE,7
	RJMP _0x21
; 0000 00A9 
; 0000 00AA         SPDR=0xE0;
	LDI  R30,LOW(224)
	OUT  0xF,R30
; 0000 00AB         while (!(SPSR & 0x80));
_0x24:
	SBIS 0xE,7
	RJMP _0x24
; 0000 00AC };
	__ADDWRN 18,19,1
	RJMP _0x1F
_0x20:
; 0000 00AD PORTB=0b00111100; //neoktivniy displey
	RJMP _0x2000001
; 0000 00AE }
;
;
;void LCD_off(void){
; 0000 00B1 void LCD_off(void){
_LCD_off:
; 0000 00B2 unsigned char i;
; 0000 00B3 PORTB=0b00101100; //oktivniy display
	ST   -Y,R17
;	i -> R17
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 00B4 for(i=0;i<=6;i++){
	LDI  R17,LOW(0)
_0x28:
	CPI  R17,7
	BRSH _0x29
; 0000 00B5 
; 0000 00B6         SPDR=LCD_off_masiv[i][0];
	RCALL SUBOPT_0x4
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00B7         while (!(SPSR & 0x80));
_0x2A:
	SBIS 0xE,7
	RJMP _0x2A
; 0000 00B8 
; 0000 00B9         SPDR=LCD_off_masiv[i][1];
	RCALL SUBOPT_0x4
	ADIW R30,1
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00BA         while (!(SPSR & 0x80));
_0x2D:
	SBIS 0xE,7
	RJMP _0x2D
; 0000 00BB 
; 0000 00BC         SPDR=LCD_off_masiv[i][2];
	RCALL SUBOPT_0x4
	ADIW R30,2
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00BD         while (!(SPSR & 0x80));
_0x30:
	SBIS 0xE,7
	RJMP _0x30
; 0000 00BE 
; 0000 00BF PORTB=0b00111100; //neoktivniy displey
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 00C0 #asm("nop")
	nop
; 0000 00C1 PORTB=0b00101100; //oktivniy display
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 00C2 };
	SUBI R17,-1
	RJMP _0x28
_0x29:
; 0000 00C3 PORTB=0b00111100; //neoktivniy displey
_0x2000002:
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 00C4 }
	LD   R17,Y+
	RET
;
;void LCD_kvadrat(void){
; 0000 00C6 void LCD_kvadrat(void){
_LCD_kvadrat:
; 0000 00C7 unsigned char i=0;
; 0000 00C8 unsigned int i1;
; 0000 00C9 PORTB=0b00101100; //oktivniy display
	RCALL SUBOPT_0x2
;	i -> R17
;	i1 -> R18,R19
; 0000 00CA for(i=0;i<=6;i++){
_0x34:
	CPI  R17,7
	BRSH _0x35
; 0000 00CB         SPDR=LCD_kvadrat_masiv[i][0];
	RCALL SUBOPT_0x5
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00CC         while (!(SPSR & 0x80));
_0x36:
	SBIS 0xE,7
	RJMP _0x36
; 0000 00CD 
; 0000 00CE         SPDR=LCD_kvadrat_masiv[i][1];
	RCALL SUBOPT_0x5
	ADIW R30,1
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00CF         while (!(SPSR & 0x80));
_0x39:
	SBIS 0xE,7
	RJMP _0x39
; 0000 00D0 
; 0000 00D1         SPDR=LCD_kvadrat_masiv[i][2];
	RCALL SUBOPT_0x5
	ADIW R30,2
	LPM  R0,Z
	OUT  0xF,R0
; 0000 00D2         while (!(SPSR & 0x80));
_0x3C:
	SBIS 0xE,7
	RJMP _0x3C
; 0000 00D3 
; 0000 00D4 PORTB=0b00111100; //neoktivniy displey
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 00D5 #asm("nop")
	nop
; 0000 00D6 PORTB=0b00101100; //oktivniy display
	LDI  R30,LOW(44)
	OUT  0x18,R30
; 0000 00D7 };
	SUBI R17,-1
	RJMP _0x34
_0x35:
; 0000 00D8         SPDR=0x76;
	LDI  R30,LOW(118)
	OUT  0xF,R30
; 0000 00D9         while (!(SPSR & 0x80));
_0x3F:
	SBIS 0xE,7
	RJMP _0x3F
; 0000 00DA 
; 0000 00DB for(i1=0;i1<=1850;i1++){                 // pixseli delaem krasnimi
	__GETWRN 18,19,0
_0x43:
	__CPWRN 18,19,1851
	BRSH _0x44
; 0000 00DC         SPDR=0xF8;
	LDI  R30,LOW(248)
	OUT  0xF,R30
; 0000 00DD         while (!(SPSR & 0x80));
_0x45:
	SBIS 0xE,7
	RJMP _0x45
; 0000 00DE 
; 0000 00DF         SPDR=0x00;
	LDI  R30,LOW(0)
	OUT  0xF,R30
; 0000 00E0         while (!(SPSR & 0x80));
_0x48:
	SBIS 0xE,7
	RJMP _0x48
; 0000 00E1 };
	__ADDWRN 18,19,1
	RJMP _0x43
_0x44:
; 0000 00E2 PORTB=0b00111100; //neoktivniy displey
_0x2000001:
	LDI  R30,LOW(60)
	OUT  0x18,R30
; 0000 00E3 }
	CALL __LOADLOCR4
	ADIW R28,4
	RET
;
;
;
;
;
;
;
;void main(void){
; 0000 00EB void main(void){
_main:
; 0000 00EC Port_init();
	RCALL _Port_init
; 0000 00ED LCD_init();
	RCALL _LCD_init
; 0000 00EE delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x0
; 0000 00EF LCD_fill();
	RCALL _LCD_fill
; 0000 00F0 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x0
; 0000 00F1 LCD_kvadrat();
	RCALL _LCD_kvadrat
; 0000 00F2 delay_ms(4000);
	LDI  R30,LOW(4000)
	LDI  R31,HIGH(4000)
	RCALL SUBOPT_0x0
; 0000 00F3 LCD_off();
	RCALL _LCD_off
; 0000 00F4 while (1)
_0x4B:
; 0000 00F5       {
; 0000 00F6 
; 0000 00F7       };
	RJMP _0x4B
; 0000 00F8 }
_0x4E:
	RJMP _0x4E

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1:
	LDI  R26,LOW(3)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_LCD_init_masiv*2)
	SBCI R31,HIGH(-_LCD_init_masiv*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2:
	CALL __SAVELOCR4
	LDI  R17,0
	LDI  R30,LOW(44)
	OUT  0x18,R30
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3:
	LDI  R26,LOW(3)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_LCD_fill_masiv*2)
	SBCI R31,HIGH(-_LCD_fill_masiv*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	LDI  R26,LOW(3)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_LCD_off_masiv*2)
	SBCI R31,HIGH(-_LCD_off_masiv*2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5:
	LDI  R26,LOW(3)
	MUL  R17,R26
	MOVW R30,R0
	SUBI R30,LOW(-_LCD_kvadrat_masiv*2)
	SBCI R31,HIGH(-_LCD_kvadrat_masiv*2)
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
