
#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>

flash unsigned char LCD_init_masiv[70][3] ={
                                      {0x74,0x00,0x00}, //1 block
                                      {0x76,0x00,0x01},
                                      {0x74,0x00,0x07},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x02},
                                      {0x76,0x04,0x00},
                                      {0x74,0x00,0x04},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x0C},
                                      {0x76,0x00,0x01},
                                      {0x74,0x00,0x0D},
                                      {0x76,0x06,0x16},
                                      {0x74,0x00,0x1E},
                                      {0x76,0x10,0x10}, //2 block
                                      {0x74,0x00,0x03},
                                      {0x76,0x00,0x0C},
                                      {0x74,0x00,0x0E},
                                      {0x76,0x2D,0x1F},
                                      {0x74,0x00,0x0D},
                                      {0x76,0x06,0x16},
                                      {0x74,0x00,0x01},
                                      {0x76,0x02,0x15},
                                      {0x74,0x00,0x0F},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x0B},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x11},
                                      {0x76,0x00,0x00}, //3 block
                                      {0x74,0x00,0x06},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x05},
                                      {0x76,0x00,0x30},
                                      {0x74,0x00,0x14},
                                      {0x76,0xAF,0x00},
                                      {0x74,0x00,0x15},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x16},
                                      {0x76,0x83,0x00},
                                      {0x74,0x00,0x17},
                                      {0x76,0xAF,0x00},
                                      {0x74,0x00,0x20},
                                      {0x76,0x00,0x00}, //4 block
                                      {0x74,0x00,0x30},
                                      {0x76,0x00,0x00},
                                      {0x74,0x00,0x31},
                                      {0x76,0x04,0x00},
                                      {0x74,0x00,0x32},
                                      {0x76,0x02,0x07},
                                      {0x74,0x00,0x33},
                                      {0x76,0x07,0x00},
                                      {0x74,0x00,0x34},
                                      {0x76,0x00,0x05},
                                      {0x74,0x00,0x35},
                                      {0x76,0x07,0x03},
                                      {0x74,0x00,0x36},
                                      {0x76,0x07,0x07}, //5 blocl
                                      {0x74,0x00,0x37},
                                      {0x76,0x00,0x07},
                                      {0x74,0x00,0x3A},
                                      {0x76,0x12,0x00},
                                      {0x74,0x00,0x3B},
                                      {0x76,0x00,0x09},
                                      {0x74,0x00,0x07},
                                      {0x76,0x00,0x05},
                                      {0x74,0x00,0x07},
                                      {0x76,0x00,0x25},
                                      {0x74,0x00,0x07},
                                      {0x76,0x00,0x27},
                                      {0x74,0x00,0x07},
                                      {0x76,0x00,0x37}
                                     };

flash unsigned char LCD_off_masiv[6][3] = {                    //masiv dlya viklyu4eniya
                                      0x74,0x00,0x0D,
                                      0x76,0x05,0x05,
                                      0x74,0x00,0x0E,
                                      0x76,0x1D,0x1F,
                                      0x74,0x00,0x03,
                                      0x76,0x00,0x00
                                         };

flash unsigned char LCD_fill_masiv[7][3] = {                 //masiv dlya zapolneniya ekrana
                                      0x74,0x00,0x16,
                                      0x76,0x83,0x00,
                                      0x74,0x00,0x17,
                                      0x76,0xAF,0x00,
                                      0x74,0x00,0x21,
                                      0x76,0x00,0x00,
                                      0x74,0x00,0x22
                                      };

flash unsigned char LCD_kvadrat_masiv[7][3] = {                 //masiv dlya zapolneniya kvadrata
                                      0x74,0x00,0x16,
                                      0x76,0x50,0x25,           //        X2                  X1
                                      0x74,0x00,0x17,
                                      0x76,0x50,0x25,           //        Y2                  Y1
                                      0x74,0x00,0x21,
                                      0x76,0x25,0x25,           //        X1                  Y1
                                      0x74,0x00,0x22
                                      };



void Port_init(void){
DDRB=0b11111111;  //vse linii kak vixod
PORTB=0b00100100; // DAT=1 i RS=1

SPCR=0b01010001;  // master, SPI-ON, CK/16
SPSR=0b00000001;  // SPI*2

PORTD=0x00;
DDRD=0xff;
}

void LCD_init(void){     // Inicializiruyu Display
unsigned char i=0;
PORTB=0b00110100;
delay_ms(1);
PORTB=0b00111100;
delay_ms(10);
PORTB=0b00101100;
for(i=0;i<=69;i++){

        SPDR=LCD_init_masiv[i][0];
        while (!(SPSR & 0x80));

        SPDR=LCD_init_masiv[i][1];
        while (!(SPSR & 0x80));

        SPDR=LCD_init_masiv[i][2];
        while (!(SPSR & 0x80));

PORTB=0b00111100; //neoktivniy displey
#asm("nop")
PORTB=0b00101100; //oktivniy display
};
PORTB=0b00111100; //neoktivniy displey
}

void LCD_fill(void){
unsigned char i=0;
unsigned int i1;
PORTB=0b00101100; //oktivniy display
for(i=0;i<=6;i++){
        SPDR=LCD_fill_masiv[i][0];
        while (!(SPSR & 0x80));

        SPDR=LCD_fill_masiv[i][1];
        while (!(SPSR & 0x80));

        SPDR=LCD_fill_masiv[i][2];
        while (!(SPSR & 0x80));

PORTB=0b00111100; //neoktivniy displey
#asm("nop")
PORTB=0b00101100; //oktivniy display
};
        SPDR=0x76;
        while (!(SPSR & 0x80));

for(i1=0;i1<=23232;i1++){                //cvet fona goltiy
        SPDR=0xFF;
        while (!(SPSR & 0x80));

        SPDR=0xE0;
        while (!(SPSR & 0x80));
};
PORTB=0b00111100; //neoktivniy displey
}


void LCD_off(void){
unsigned char i;
PORTB=0b00101100; //oktivniy display
for(i=0;i<=6;i++){

        SPDR=LCD_off_masiv[i][0];
        while (!(SPSR & 0x80));

        SPDR=LCD_off_masiv[i][1];
        while (!(SPSR & 0x80));

        SPDR=LCD_off_masiv[i][2];
        while (!(SPSR & 0x80));

PORTB=0b00111100; //neoktivniy displey
#asm("nop")
PORTB=0b00101100; //oktivniy display
};
PORTB=0b00111100; //neoktivniy displey
}

void LCD_kvadrat(void){
unsigned char i=0;
unsigned int i1;
PORTB=0b00101100; //oktivniy display
for(i=0;i<=6;i++){
        SPDR=LCD_kvadrat_masiv[i][0];
        while (!(SPSR & 0x80));

        SPDR=LCD_kvadrat_masiv[i][1];
        while (!(SPSR & 0x80));

        SPDR=LCD_kvadrat_masiv[i][2];
        while (!(SPSR & 0x80));

PORTB=0b00111100; //neoktivniy displey
#asm("nop")
PORTB=0b00101100; //oktivniy display
};
        SPDR=0x76;
        while (!(SPSR & 0x80));

for(i1=0;i1<=1850;i1++){                 // pixseli delaem krasnimi
        SPDR=0xF8;
        while (!(SPSR & 0x80));

        SPDR=0x00;
        while (!(SPSR & 0x80));
};
PORTB=0b00111100; //neoktivniy displey
}







void main(void){
Port_init();
LCD_init();
delay_ms(2000);
LCD_fill();
delay_ms(2000);
LCD_kvadrat();
delay_ms(4000);
LCD_off();
while (1)
      {

      };
}
